



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>5 Logistic回归（一）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">5 Logistic回归（一）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-23 15:49:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>首次接触最优化算法。介绍几个最优化算法，并利用它们训练出一个<strong>非线性</strong>函数用于分类。</p>
<p>假设现在有一些数据点，我们利用一条直线对这些点进行拟合（该直线为最佳拟合直线），这个拟合过程称作回归。</p>
<p>利用Logistic回归进行分类思想：根据现有数据对分类边界线建立回归公式，以此进行分类。</p>
<p>这里的&ldquo;回归&rdquo;一词源于最佳拟合，表示找到最佳拟合参数。训练分类器的做法：寻找最佳拟合参数，使用的是最优化算法（梯度上升法、改进的随机梯度上升法）。</p>
<p><strong>5.1 基于Logistic回归和Sigmoid函数的分类</strong></p>
<p>Logistic回归：优点：计算代价不高，易于理解和实现。缺点：容易欠拟合，分类精度可能不高。适用数据类型：数值型、标称型。</p>
<p>Sigmoid函数：g(z)=1/(1+e<sup>-z</sup>)，也可表示为h<sub>&Theta;</sub>(X)=g(&Theta;<sup>T</sup>X).</p>
<p>为了实现Logistic回归分类器，我们需要在每个特征上乘以一个<strong>回归系数</strong>，然后把<strong>所有结果值相加</strong>，将这个总和代入Sigmoid函数，进而得到0~1之间的数值。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/756771/201602/756771-20160205133510007-1758283857.png" /></p>
<p>此时就可以对标签y进行分类了：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150414211530529?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTHU1OTcyMDM5MzM=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>其中&theta;<sup>T</sup>x=0 即&theta;0+&theta;1*x1+&theta;2*x2=0 称为决策边界即boundarydecision。</p>
<p><strong>Cost function:</strong></p>
<p>线性回归的cost function依据最小二乘法是最小化观察值和估计值的差平方和。即：</p>
<p><strong><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150414211501282?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTHU1OTcyMDM5MzM=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></strong></p>
<p>但是对于logistic回归，我们的cost fucntion不能最小化观察值和估计值的差平法和，因为这样我们会发现J(&theta;)为非凸函数，此时就存在很多局部极值点，就无法用梯度迭代得到最终的参数(来源于AndrewNg video)。因此我们这里重新定义一种cost function</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150414211620231?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTHU1OTcyMDM5MzM=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>通过以上两个函数的函数曲线，我们会发现当y=1，而估计值h=1或者当y=0，而估计值h=0,即预测准确了，此时的cost就为0，，但是当预测错误了cost就会无穷大，很明显满足cost function的定义。</p>
<p>可以将上面的分组函数写在一起：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150414211643397?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTHU1OTcyMDM5MzM=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>这样得到总体的损失函数J(&theta;)为：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150419210222437?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTHU1OTcyMDM5MzM=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p><strong>5.2 基于最优化方法的最佳回归系数确定</strong></p>
<p>Sigmoid函数输入记为z, z=w<sub>0</sub>x<sub>0</sub>+w<sub>1</sub>x<sub>1</sub>+...+w<sub>n</sub>x<sub>n。</sub>如果采用向量的写法，z=w<sup>T</sup>x,表示将这两个数值向量对应的元素相乘然后全部加起来得到z值。</p>
<p>其中向量x是分类器的输入数据，向量w就是我们要找到的最佳参数（系数）。</p>
<p><strong>5.2.1 梯度上升法</strong></p>
<p>梯度上升法思想：要找到某个函数的最大值，最好的方法是沿着该函数的梯度方向探寻。如果梯度记为▽，则函数f(x,y)的梯度由下式表示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/756771/201602/756771-20160205113715366-349304058.png" />。这个梯度意味着沿x方向移动<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/756771/201602/756771-20160205113827944-1350383675.png" />，沿y方向移动<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/756771/201602/756771-20160205113855382-1395092832.png" />。其中，函数f(x,y)必须在待计算的点上有定义并且可微。</p>
<p>这样我们依据上面的J(&theta;)就可以得到梯度上升的公式：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150414211730805?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTHU1OTcyMDM5MzM=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>当然上图中少了个求和符号。这样就得到</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150414211707783?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTHU1OTcyMDM5MzM=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>当然对于随机化的梯度迭代每次只使用一个样本进行参数更新，就为：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150414211726706?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTHU1OTcyMDM5MzM=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>这也是下面代码中公式的来源。</p>
<p>例如：data=[1,2,3;4,5,6;7,8,9;10,11,12]为4个样本点，3个特征的数据集，，此时标签为[1,0,0,0]，</p>
<p>那么用梯度上升<img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150414211802711?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTHU1OTcyMDM5MzM=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />&nbsp;&nbsp;表达的就是当j=0时，就是第一列[1,4,7,10]与标签差的乘积。。这个自己体会下吧。。</p>
<p><strong>为什么要采用上面的函数作为cost function？</strong></p>
<p>Andrew Ng给的解释是因为最小估计值和观察值的差平方和为非凸函数，通过函数曲线观察得到上面的cost function满足条件。</p>
<p>这里给出另外一种解释&mdash;&mdash;最大似然估计:</p>
<p>我们知道h<sub>&theta;</sub>(x)&ge;0.5&lt;后面简用h&gt;,此时y=1， 小于0.5，y=0. 那么我们就用h作为y=1发生的概率，那么当y=0时，h＜0.5，此时不能用h作为y=0的概率，&lt;因为最大似然的思想使已有的数据发生的概率最大化，小于0.5太小了&gt;，我们可以用1-h作为y=0的概率，这样就可以作为y=0的概率了，，然后只需要最大化联合概率密度函数就可以了。</p>
<p>这样联合概率密度函数就可以写成：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150414211922361?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTHU1OTcyMDM5MzM=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>再转换成对数似然函数，就和上面给出的似然函数一致了。</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150414211900649?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTHU1OTcyMDM5MzM=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/756771/201602/756771-20160205114053632-1572055328.png" /></p>
<p>图5-2 &nbsp;梯度上升算法到达每个点后都会重新估计移动的方向</p>
<p>图5-2中的梯度上升算法沿梯度方向移动了一步。梯度算子总是指向函数值增长最快的方向。这里说的移动方向，而未提到移动量的大小。该量值称为步长，记做&alpha;。用向量来表示的话，梯度上升算法的迭代公式如下： <em>w</em>:=<em>w</em>+&alpha;▽<em><sub>w</sub>f(w).</em></p>
<p>该公式将一直进行迭代，直到达到某个停止条件为止，比如迭代次数达到某个指定值或算法达到某个可以允许的误差范围。</p>
<p><strong>5.2.2 训练算法：使用梯度上升找到最佳参数</strong></p>
<p>训练样本：100个样本点，每个点包含两个数值型特征：x1和x2.</p>
<div>
<pre class="prettyprint linenums">#coding:utf-8<br />
from numpy import *

def loadDataSet():#便利函数：打开文件并逐行读取<br />
    dataMat = []; labelMat = []<br />
    fr = open('testSet.txt')<br />
    for line in fr.readlines():<br />
        lineArr = line.strip().split()<br />
        dataMat.append([1.0, float(lineArr[0]), float(lineArr[1])])#为方便计算，将x0值设为1.0<br />
        labelMat.append(int(lineArr[2]))<br />
    return dataMat, labelMat

def sigmoid(inX):<br />
    return 1.0/(1+exp(-inX))

def gradAscent(dataMatIn, classLabels):#梯度上升：dataMatIn:2维NumPy数组,100*3矩阵;classLabels:类别标签，1*100行向量<br />
    dataMatrix = mat(dataMatIn)#特征矩阵<br />
    labelMat = mat(classLabels).transpose()#类标签矩阵：100*1列向量<br />
    m,n = shape(dataMatrix)<br />
    alpha = 0.001#向目标移动的步长<br />
    maxCycles = 500#迭代次数<br />
    weights = ones((n,1))#n*1列向量：3行1列<br />
    for k in range(maxCycles):<br />
        h = sigmoid(dataMatrix*weights)#100*3*3*1=100*1,dataMatrix * weights代表不止一次乘积计算，事实上包含了300次乘积<br />
        error = (labelMat - h)#真实类别与预测类别的差值<br />
        weights = weights + alpha * dataMatrix.transpose()* error#w:=w+&alpha;▽wf(w)<br />
    return weights
        </pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/756771/201602/756771-20160205125105007-1900582364.png" /></p>
<p><strong>注：</strong>倒数第二行代码</p>
<pre class="prettyprint linenums"> weights = weights + alpha * dataMatrix.transpose()* error#w:=w+&alpha;▽wf(w)</pre>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/756771/201602/756771-20160205125510507-1124116382.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/756771/201602/756771-20160205125516632-1539270105.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/756771/201602/756771-20160205125522085-846960624.png" /></p>
<p><strong>5.2.3 分析数据：画出决策边界</strong></p>
<p>上面已经解出一组回归系数，它确定了不同类别数据之间的分隔线。如何画出分隔线，从而使得优化过程便于理解？</p>
<div>
<pre class="prettyprint linenums">#5-2:画出数据集和Logistic回归最佳拟合直线的函数<br />
def plotBestFit(weights):<br />
    import matplotlib.pyplot as plt<br />
    dataMat, labelMat = loadDataSet()<br />
    dataArr = array(dataMat)<br />
    n = shape(dataArr)[0]#n=100<br />
    xcord1 = []; ycord1 = []<br />
    xcord2 = []; ycord2 = []<br />
    for i in range(n):<br />
        if int(labelMat[i]) == 1:<br />
            xcord1.append(dataArr[i, 1]); ycord1.append(dataArr[i, 2])<br />
        else:<br />
            xcord2.append(dataArr[i, 1]); ycord2.append(dataArr[i, 2])<br />
    fig = plt.figure()<br />
    ax = fig.add_subplot(111)<br />
    ax.scatter(xcord1, ycord1, s=30, c='red', marker='s')<br />
    ax.scatter(xcord2, ycord2, s=30, c='green')<br />
    x = arange(-3.0, 3.0, 0.1)#arange创建等差数组,-3.0起始点,3.0终止点(不包含3.0),间隔为0.1<br />
    y = (-weights[0] - weights[1] * x)/weights[2]#最佳拟合直线,设置sigmoid函数为0,0是两个分类(类别1和类别0)的分界处。因此设定0=w0x0+w1x1+w2x2,解出x1和x2关系(即分割线的方程，x0=1)。<br />
    ax.plot(x, y)<br />
    plt.xlabel('X1');plt.ylabel('X2');<br />
    plt.show()</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/756771/201602/756771-20160205151607335-1964080925.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/756771/201602/756771-20160205151617210-423966627.png" /></p>
<p>这个分类结果相当不错，尽管例子简单且数据集很小，这个方法却需要大量的计算（300次乘法）。</p>
<p>因此下一节将对该算法稍作改进，从而使它可以用在其他真是数据上。</p>
<p><strong>注明：5.1参考下面链接</strong></p>
<pre class="prettyprint linenums">作者：小村长 &nbsp;出处：<a href="http://blog.csdn.net/lu597203933" rel="external nofollow noreferrer">http://blog.csdn.net/lu597203933</a></pre>
<pre class="prettyprint linenums"></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8ko7r3q.html">跟我从零基础学习Unity3D开发--U3d脚本注意事项及两个基本函数的简单介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/495w0w09.html">AC自动机及trie图 pascal</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ejvmm9.html">【FTP】FTP文件上传下载-支持断点续传</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql2km18.html">hash-2&period;hashMap</a>
		</li>
						<li><a href="https://www.batexi.com/a/495ooy08.html">Ruby on Rails 和 J2EE：两者能否共存？</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyz3yg9.html">在阿里云主机的Debian操作系统上安装Docker</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w5v4xq.html">java NIO经典实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvzoozq.html">最精简的IOCP封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wnwr3q.html">Android 70道面试题汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmd6p19.html">利用java实现一个简单的远程监控程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v6mzo8.html">windows下批量杀死进程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydmgl2q.html">Triangle 解答</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpjgo69.html">PureMVC&lpar;JS版）源码解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1v03gq.html">TreeSet与TreeMap的源码分析 JDK7</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkx5ge8.html">Linux 将本地文件上传Linux服务器&comma; 即ssh 命令上传本地文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljdmv69.html">使用Intellij IDEA生成JavaDoc</a>
		</li>
						<li><a href="https://www.batexi.com/a/96prp3y8.html">Docker常用名称</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k7lrz9.html">Linux 系统目录结构说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rmrwm9.html">JavaScript：鼠标拖拽效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvnnv38.html">SSIS 包部署错误 0xC0010014</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93x5dzr9.html">iOS分类</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok757e9.html">【11&period;2noip冲刺赛】 循环整数 （分段打表）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1ze4r59.html">sublime less高亮插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x6dyv8.html">ie兼容---haslayout</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yxdxnq.html">android studio SVN的搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x6z308.html">Composer加速</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdo6pm8.html">最长增长子序列 DP</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wrylwq.html">Oracle EBS-SQL &lpar;WIP-12&rpar;&colon;总装车间任务查询&period;sql</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdokvr8.html">css 问题总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn13l7j8.html">java--工具方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
